/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */

#include <stdio.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <netinet/in.h>
#include <errno.h>
#include "vector.h"
#include "units.h"


#include <assert.h>

#define NDEBUG
#define MAXNEEDED (1024*256)

extern XFontStruct *vsmallFont;

GC brushedGC, tiledGC;
extern GC uniGC;
static char *buffer;
long lastmax;
int lastj;

/* search through all layers (files) in a particular dataset */
aDrawLayers(char *name)
{
    char lyrpath[60], basepath[60];
    struct stat fstat;

    strcpy(basepath, name);
    strcpy(lyrpath, basepath);
    strcat(lyrpath, ".lyr");
    if (stat(lyrpath, &fstat)) {
	perror(lyrpath);
	exit(1);
    }
    aDrawObjects(basepath, name);
}

/* search through all objects in a particular layer */
aDrawObjects(char *basename, char *name)
{
    long numrecs, i = 0;
    char *extsum = ".sum", *extobj = ".obj";
    char sum[70], obj[70];
    SummaryRec *s, *p, q;
    char *sumfile, *objfile;
    int fdsum, fdobj;
    int err, size = sizeof(SummaryRec), fnum;
    struct stat statbuf;
    long sumsize, objsize;
    MapObject object;
    char bufp[1024];

    strcpy(sum, basename);
    strcpy(obj, basename);
    strcat(sum, extsum);

    if ((fdsum = open(sum, O_RDONLY)) == -1) {
	sprintf(bufp, "DrawObjects: %s", sum);
	perror(bufp);
    }
    fstat(fdsum, &statbuf);
    sumsize = statbuf.st_size;
    sumfile = mmap(0, sumsize, PROT_READ, MAP_SHARED, fdsum, 0);

    strcat(obj, extobj);

    if ((fdobj = open(obj, O_RDONLY)) == -1) {
	sprintf(bufp, "DrawObjects: %s", obj);
	perror(bufp);
    }
    fstat(fdobj, &statbuf);
    objsize = statbuf.st_size;
    objfile = mmap(0, objsize, PROT_READ, MAP_SHARED, fdobj, 0);

    for (p = (SummaryRec *) sumfile; (void *) p < (void *) (sumfile + sumsize); p++) {
	i++;

	s = &q;
	memcpy(s, p, sizeof(q));
	s->offset = ntohl(s->offset);
	s->bounds.WLon = ntohl(s->bounds.WLon);
	s->bounds.SLat = ntohl(s->bounds.SLat);
	s->bounds.ELon = ntohl(s->bounds.ELon);
	s->bounds.NLat = ntohl(s->bounds.NLat);

	if (s->offset < 0) {	/* Deleted record or alias? -- ignore */
	    continue;
	}
	CenterMBR(&s->bounds);
	if (1) {
	    FGetObj(objfile, &object, s->offset);
	    switch (object.type) {
	    case LINESTRING:
		break;
	    case POLYGON:
		break;
	    case POINT:
		break;
	    case ALIAS:
		break;
	    case TEXT:
		break;
	    case RECT:
		break;
	    default:
		fprintf(stderr, "ERROR %s(%i)\n", name, object.type);
		exit(2);
	    }
	}
    }
    munmap(sumfile, sumsize);
    munmap(objfile, objsize);
    close(fdsum);
    close(fdobj);
}

int main(int argc, char **argv)
{
    if (argc != 2)
	exit(1);
    aDrawLayers(argv[1]);
    return 0;
}
